//Jiaxin Wen
//Section B
//jiaxinw@andrew.cmu.edu
//Final project

// origin color for buttons
var col2 = 255;
var col1 = 255;
var col3 = 255;
var col4 = 255;
var col5 = 255;
var col6 = 255;

//kinect hands position
var lhx = 0;
var lhy = 0;
var rhx = 0;
var rhy = 0;

//arrays for particle effets
var bubbleArr = [];
var cubeArr = [];
var lineArr = [];
var pieArr = [];

//button 6 offset
var offset = 1;
var but6a = 255;

//sounds variables
var butSound1;
var butSound2;
var butSound3;
var butSound4;
var butSound5;
var butSound6;

function preload_jx(){
    butSound1 = loadSound("bass.wav");
    butSound2 = loadSound("edmMel.mp3");
    butSound3 = loadSound("electron.mp3");
    butSound4 = loadSound("edmPluck.wav");
    butSound5 = loadSound("edmKick.wav");
    butSound6 = loadSound("edmLoop.mp3");
}

function setup_jx() {
    createCanvas(1920, 1080);
   
}

function draw_jx() {
     
    //the big radius of buttons
    var br = -height*0.35;
    //the width of buttons
    var bw = width*0.13;
    //the height of buttons
    var bh = height*0.005;

    push();

    translate(width/2,height/2)
    rectMode(CENTER);
    angleMode(DEGREES)

    //Create 6 buttons on the screen, and touch any of them will trigger 
    //a particle effect and a sound effect

    //button 1
    if ((lhy<height/4 && lhx>width/2-bw/2 && lhx<width/2+bw/2) 
      || (rhy<height/4 && rhx>width/2-bw/2 && rhx<width/2+bw/2)){
        //visual change - bubble effect
        col1=color(250,20,20,70);
        var bubble = new Bubbles();
        bubbleArr.push(bubble);
        for (var i = 0; i < bubbleArr.length; i++) {
            bubbleArr[i].move();
            bubbleArr[i].show();
        }

        //sound
        if(butSound1.isPlaying()==false){
            butSound1.play()
        }

    } else {
        col1=color(255,70);
    }
    push();
    for (var i = 0; i < 7; i++) {
        noStroke()
        fill(col1);
        rect(0,br,bw+(i*2),bh+(i*2))
    }
    pop();

    //button 2
    if ((lhy>height/4 && lhy<height/2-bh/2 && lhx>width/2+bw && lhx<width/2+bw*2) 
      || (rhy>height/4 && rhy<height/2-bh/2 && rhx>width/2+bw && rhx<width/2+bw*2)){
        //visual change - square effects
        col2=color(246,255,0,70);
        var cube = new Cubes();
        cubeArr.push(cube);
        for (var i = 0; i < cubeArr.length; i++) {
            cubeArr[i].move();
            cubeArr[i].show();
        }

        //sound
        if(butSound2.isPlaying()==false){
            butSound2.play()
        }

    } else{
        col2=color(255,70);
    }
    push();
    rotate(60);
    for (var i = 0; i < 7; i++) {
        noStroke()
        fill(col2);
        rect(0,br,bw+(i*2),bh+(i*2))
    }
    pop();

    //button 3
    if ((lhy>height/2+bh && lhy<height/2+bw*1.5 && lhx>width/2+bw && lhx<width/2+bw*2) 
      || (rhy>height/2+bh && rhy<height/2+bw*1.5 && rhx>width/2+bw && rhx<width/2+bw*2)){
        //visual change - lines effect
        col3=color(24,61,247,70) 
        var line = new Lines();
        lineArr.push(line);
        for (var i = 0; i < lineArr.length; i++) {
        lineArr[i].move();
        lineArr[i].show();
        }

        //sound
        if(butSound3.isPlaying()==false){
            butSound3.play()
        }

    } else{
        col3=color(255,70);
   
    }
    push();
    rotate(120);
    for (var i = 0; i < 7; i++) {
        noStroke()
        fill(col3);
        rect(0,br,bw+(i*2),bh+(i*2))
    }
    pop();

    //button4
    if ((lhy>height/4*3 && lhx>width/2-bw/2 && lhx<width/2+bw/2)
        ||(rhy>height/4*3 && rhx>width/2-bw/2 && rhx<width/2+bw/2)){
        //visual change - arc effects
        col4=color(255,120,0,70);
        var pie = new Pies();
        pieArr.push(pie);
        for (var i = 0; i < pieArr.length; i++) {
            pieArr[i].move();
            pieArr[i].show();
        } 

        //sound
        if(butSound4.isPlaying()==false){
            butSound4.play()
        }

    } else{
        col4=color(255,70);
    }
    push();
    rotate(180);
    for (var i = 0; i < 10; i++) {
        noStroke()
        fill(col4);
        rect(0,br,bw+(i*2),bh+(i*2))
    }
    pop();

    //button5
    if ((lhy>height/2+bh && lhy<height/2+bw*1.5 && lhx<width/2-bw && lhx>width/2-bw*2)
        ||(rhy>height/2+bh && rhy<height/2+bw*1.5 && rhx<width/2-bw && rhx>width/2-bw*2)){
        col5=color(21,218,82,70) 
        // visual effect - a big ball
        ball();

        //sound
        if(butSound5.isPlaying()==false){
            butSound5.play()
        }

    } else{
        col5=color(255,70);
    }
    push();
    rotate(240);
    for (var i = 0; i < 7; i++) {
        noStroke()
        fill(col5);
        rect(0,br,bw+(i*2),bh+(i*2))
    }
    pop();


    //button6
    push();
    rotate(300);
     if ((lhy>height/4 && lhy<height/2-bh/2 && lhx<width/2-bw && lhx>width/2-bw*2)
        ||(rhy>height/4 && rhy<height/2-bh/2 && rhx<width/2-bw && rhx>width/2-bw*2)){
        col6=color(192,0,255,70)
        noStroke()
        //visual effect - create patterns on the button
        fill(192,0,255,but6a);
        rect(0,br,bw/32,bh*offset);
        rect(bw/8,br,bw/32,bh*offset);
        rect(bw/4,br,bw/32,bh*offset);
        rect(bw/2,br,bw/32,bh*offset);
        rect(-bw/8,br,bw/32,bh*offset);
        rect(-bw/4,br,bw/32,bh*offset);
        rect(-bw/2,br,bw/32,bh*offset);
        offset +=2 ;
        but6a -= 5;
        if (offset>70||but6a<0){
            offset=1;
            but6a=255;
        }  

        //sound
        if(butSound6.isPlaying()==false){
            butSound6.play()
        }

    } else{
        col6=color(255,70);
    }
    for (var i = 0; i < 7; i++) {
        noStroke()
        fill(col6);
        rect(0,br,bw+(i*2),bh+(i*2))
    }
    pop();

    pop();

}

//create different particle effects for buttons 
class Bubbles{
    constructor(){
        this.x = 0;
        this.y = -height/3;
        this.a = 255;
        this.vx = random(-2,2);
        this.vy = random(-1,5);
        this.r = 7;
    };

    move(){
        this.x += this.vx;
        this.y += this.vy;
        this.a -= 3;
        this.r += 0.2;
    }

    show() {
        stroke(250,20,20,this.a);
        strokeWeight(2);
        ellipse(this.x, this.y, this.r)
    }
}

class Cubes{
    constructor(){
        this.x = width*0.22;
        this.y = -height/5;
        this.a = 255;
        this.vx = random(-4,1);
        this.vy = random(-1,3);
        this.r = 30;
    };

    move(){
        this.x += this.vx;
        this.y += this.vy;
        this.a -= 3;
        this.r -= 0.2;
       
    }

    show() {
        stroke(246,255,0,this.a);
        strokeWeight(2);
        rect(this.x, this.y, this.r,this.r);

    }
   
}

class Lines{
    constructor(){
        this.x = width*0.23;
        this.y = height/5;
        this.a = 255;
        this.vx = random(-5,1);
        this.vy = random(-5,1);
        this.w = 3;
        this.h = 100;
    };

    move(){
        this.x += this.vx;
        this.y += this.vy;
        this.a -= 3;
        this.h -= 1; 
        if (this.h<0){
            this.h = 0;
        }
    }

    show() {
        noStroke();
        fill(24,61,247,this.a);
        rect(this.x, this.y, this.w,this.h);
    }
   
}

class Pies{
    constructor(){
        this.x = width*0.2;
        this.y = height/9;
        this.a = 255;
        this.vx = random(-6,1);
        this.vy = random(-3,1);
        this.r = 40;
    };

    move(){
        this.x += this.vx;
        this.y += this.vy;
        this.a -= 3;
        this.r += 0.5;
    }

    show() {
        stroke(255,120,0,this.a);
        push();
        rotate(75);
        arc(this.x,this.y,this.r,this.r,0,PI*8, PIE);
        pop();

    }
   
}

var ballR=100;
var balla=255;

function ball(){

    noStroke();
    fill(21,218,82,balla);
    ellipse(-width*0.2,height/6,ballR)
    ballR += 8;
    balla -= 4;

    if(ballR>450||balla <0){
        ballR=50;
        balla =255
    }
}