var Kinect2 = require('kinect2'),
    express = require('express'),
    app = express(),
    server = require('http').createServer(app),
    io = require('socket.io').listen(server);

var kinect = new Kinect2();

if(kinect.open()) {
    server.listen(8000);
    console.log('Server listening on port 8000');
    console.log('Point your browser to http://localhost:8000');

    //get resources and upload them to server
    app.get('/', function(req, res) {
        res.sendFile(__dirname + '/index.html');
    });

    app.get('/jiaxin.js', function(req, res) {
        res.sendFile(__dirname + '/jiaxin.js');
    });

    app.get('/nayeon.js', function(req, res) {
        res.sendFile(__dirname + '/nayeon.js');
    });

    app.get('/bass.wav', function(req, res){
        res.sendFile(__dirname + '/sounds/bass.wav'); 
    });

    app.get('/edmMel.mp3', function(req, res){
        res.sendFile(__dirname + '/sounds/edmMel.mp3'); 
    });

    app.get('/edmLoop.mp3', function(req, res){
        res.sendFile(__dirname + '/sounds/edmLoop.mp3'); 
    });

    app.get('/edmKick.wav', function(req, res){
        res.sendFile(__dirname + '/sounds/edmKick.wav'); 
    });

    app.get('/edmPluck.wav', function(req, res){
        res.sendFile(__dirname + '/sounds/edmPluck.wav'); 
    });

    app.get('/electron.mp3', function(req, res){
        res.sendFile(__dirname + '/sounds/electron.mp3'); 
    });

     app.get('/city.mp3', function(req, res){
        res.sendFile(__dirname + '/sounds/city.mp3'); 
    });


    kinect.on('bodyFrame', function(bodyFrame){
        io.sockets.emit('bodyFrame', bodyFrame);
    });

    kinect.openBodyReader();
}

